#include "mp3dec.h"

char	*outfile = "/dev/audio";
int	debug;

void main( int argc, char *argv[] )
{
	int	decode;
	char	*fname;

	ARGBEGIN {
	case 'd':
		debug++;
		break;
	case 'o':
		outfile = ARGF();
		if (outfile == nil)
			goto Usage;
		break;
	case 'w':
		audio_write = wav_write;
		break;
	default:
Usage:
		fprint(2, "usage: mp3dec [-o outfile] [-w] [file]\n");
		exits("usage");
	}
	ARGEND

		if ( argc != 0 && argc != 1)
		goto Usage;

	if ( argc == 0 ) {
		fname = "/fd/0";
	} else {
		fname = argv[0];
	}

	setfcr(getfcr() & ~FPINVAL);

	if ( MPG_Stream_Open( fname ) ) {
		sysfatal( "can't open: %s: %r", argv[0] );
	}

	while ( MPG_Get_Filepos() != C_MPG_EOF ) {

		if ( MPG_Read_Frame() == OK ) {
			decode = TRUE;
		} else {
			if ( MPG_Get_Filepos() == C_MPG_EOF ) {
				break;
			} else {
				decode = FALSE;
				ERR( "Not enough data to decode frame\n" );
			}
		}

		if ( decode ) {
			MPG_Decode_L3 ();
		}
	}

	MPG_Stream_Close();
	exits( nil );
}


