/******************************************************************************
*
* File output functions
*
******************************************************************************/

/* Include files */
#include "mp3dec.h"

/* External functions and variables (defined elsewhere, and used here) */
extern char	*outfile;
static Biobuf *bio;

/* Start of code */

static void outfile_open( void )
{
	bio = Bopen( outfile, OWRITE );
	if ( bio == nil )
		sysfatal( "can't open: %s: %r\n", outfile );
}


void raw_write( uint *samples, uint nsamples, int sample_rate )
{
	static int	init = 0;

	if ( init == 0 ) {
		init = 1;
		outfile_open();
	}

	Bwrite( bio, samples, nsamples );
}


void wav_write( uint *samples, uint nsamples, int sample_rate )
{
	static int	init = 0;
	int	i, l/*, nch*/;

	if ( init == 0 ) {
		init = 1;
		outfile_open();

		Bwrite( bio, "RIFF", 4 );
		Bwrite( bio, &i, 4 );
		Bwrite( bio, "WAVE", 4 );
		Bwrite( bio, "fmt ", 4);

		i = 16; 
		Bwrite( bio, &i, 4 );
		i = 1; 
		Bwrite( bio, &i, 2 );
		i = 2; 
		Bwrite( bio, &i, 2 );
		Bwrite( bio, &sample_rate, 4 );
		i = sample_rate * 4; 
		Bwrite( bio, &i, 4 );
		i = 4; 
		Bwrite( bio, &i, 2 );
		i = 16; 
		Bwrite( bio, &i, 2 );
		Bwrite( bio, "data", 4 );
		Bwrite( bio, &i, 4 );
	}

	if (nsamples) {
		Bwrite( bio, samples, nsamples );
	} else {
		l = Boffset( bio );
		Bseek( bio, 4, 0 );
		i = l - 8;
		Bwrite( bio, &i, 4 );
		Bseek( bio, 40, 0 );
		i = l - 44;
		Bwrite( bio, &i, 4 );
		Bterm( bio );
	}
}


